Program MultiPrint;
uses Crt,Dos,Graph;
type
  Data = string[25];
const
  Max=59;
  N : word = 94;
  current : byte = 4;
  Path : string = 'D:\SPECTRUM\NAKL-60\';
  GrMode : byte = 1;         {0 .. 5}
  Size   : integer = 249;    {1 .. 512}
  Double : byte = 1;         {1 .. 2}
  Ins    : boolean =false;
  Column : byte = 1;         {1 .. 4}
  Row    : byte = 1;         {1 ...}
  Dt : array [1..Max] of Data = (
    #1'SEX GAMES',
    #4' (Monty)',
    #5' ',
    #6'  ',
    #7'NEW GAMES',
    #8'SINCLAIR GAMES',
    #9'/',
   #10'  ',
   #11' ',
   #12' ',
   #13' ',
   #15' ',
   #16'',
   #17' ',
   #18' ',
   #19'',
   #21' ',
   #22'',
   #23'',
   #25' ',
   #26' ',
   #27'New SEX GAMES',
   #28'   ',
   #29' ',
   #30'஢ ',
   #31'  ZX-SPECTRUM',
   #32' ',
   #33'SPECTRUM GAMES',
   #34'ZX-SPECTRUM GAMES',
   #35'  ZX-SPECTRUM',
   #36'  ᪮ 몥',
   #37'SUPER GAMES',
   #38' ',
   #40'  ',
   #42'  ',
   #43'  ',
   #44'ZX SPECTRUM Games',
   #45',,',
   #46'  ',
   #47' ',
   #48' ',
   #49'/',
   #50' / ',
   #60' ',
   #61' ',
   #62'GREATEST HITS',
   #63'STAR WARS',
   #64' ',
   #65' ',
   #66'ORIGINAL GAMES',
   #67'   ',
   #68'',
  #100'BEST GAMES (Zombi)',
  #101'GAMES FOR 128k',
  #102'  128k',
  #103'  128k',
  #104'MUSIC SOUND DEMO',
  #105'LYRA-2  SHOCK',
  #106'128k SPECTRUM GAMES');
{---------------------------------------}
var
  Sc : array [0..31,0..191] of byte;
  Num : array [0..9] of pointer;
  Sym : array [1..10] of pointer;
  i,j,k : integer;
  F : Text;
  FName,s: string;
  c : char;
  R : registers;
{---------------------------------------}
Procedure  Print(s : string);
var
  i:word;
begin
  for i:=1 to length(s) do
    begin
      repeat
      r.ah:=2;
      r.dx:=0;
      Intr($17,r);
      until (r.ah and $90)=$90;
      r.ah:=0;
      r.dx:=0;
      r.al:=ord(s[i]);
      Intr($17,r);
    end
end;
{---------------------------------------}
Procedure GetZXscr;
begin
  Assign(F,FName);
  {$I-}
  Reset(F);
  {$I+}
  if IOResult<>0 then begin SetTextStyle(1,0,5);
                            for i:=0 to 31 do for j:=0 to 191 do
                                 Sc[i,j]:=$AA;
                            OutTextXY(20,320,'File Absent');
                            FName:=Path+'Compact.$c';
                            n:=94;
                            exit;
                          end;
  for i:=1 to 17 do begin Read(F,c);end;
  for k:=0 to 6143 do
    begin
      Read(F,c);
      i:=k mod 32;
      j:=k mod 2048;
      j:=j div 256 + j mod 256 div 32 * 8 + (k - j) div 32;
      Sc[i,j]:=ord(c);
    end;
  close(f);
end;
{---------------------------------------}
Procedure Pause;
begin
  repeat until KeyPressed;
  c:=ReadKey;
  if c=#0 then c:=ReadKey;
end;
{---------------------------------------}
Function InputStr(mess:string):string;
var nx:byte;
begin
  while Keypressed do ReadKey;
  SetFillStyle(1,Black);
  OutTextXY(1,250,mess);
  s:='';
  nx:=0;
  repeat
  OutTextXY(1,290,'>'+s);
  Pause;
  case c of
   ' '..#126: if nx < 40 then
                          begin
                            s:=s+c;
                            nx:=nx+1;
                          end;
   #13:begin InputStr:=s; exit; end;
   #0:ReadKey;
   #08:if nx > 0 then
                          begin
                            Delete(s,length(s),1);
                            nx:=nx-1;
                            Bar(1,290,800,330);
                          end;
  end;
  until false;
end;
{---------------------------------------}
Procedure GetFName;
var
  nn : integer;
  name:string[8];
begin
  SetColor(Green);
  SetBkColor(Black);
  if ins then
    begin
      name:=InputStr('Input Cassette Number:');
      val(name,nn,i);
      if i<>0 then exit;
      n:=nn;
      str(n,name);
      name:=name+'-60';
    end
  else
    begin
     name:=InputStr('Input ZX Screen Name:');
     if name='' then exit;

    end;
  FName:=Path+name+'.$C';
end;
{---------------------------------------}
Procedure OpenGr;
begin
  j:=detect;
  i:=1;
  InitGraph(j,i,'D:\TP7\BGI');
  if GraphResult <> grOk then begin writeln('Graph Mode Error');Halt(1);end;
  SetColor(LightGray);
end;
{---------------------------------------}
Procedure CloseGr;
begin CloseGraph end;
{---------------------------------------}
Procedure ViewZXscr(x:word);
var m:byte;
begin
 for i:=0 to 191 do
  begin
  SetColor(Red);
  Line(x+0,i+2,x+255,i+2);
  for j:=0 to 31 do
   begin
   m:=Sc[j,i];
   for k:=0 to 7 do
      begin
      PutPixel(x+j*8+k,i,(1-(128 and m) div 128)*LightGray);
      m:=m shl 1
     end;
   end;
  end;
end;
{---------------------------------------}
Procedure Inset;
const yP = 197;
var
  is : string;
begin
  is:='Mednonogov bros.';
  for i:=1 to Max do
    if Dt[i][1]=chr(n) then is:=copy(Dt[i],2,24);
  SetTextStyle(0,0,1);
  SetFillStyle(1,Cyan);
  Bar(0,192,256,217);
  SetColor(0);
  is:=copy('               ',1,(22-length(is)) div 2)+is;
  OutTextXY(80,yP,is);
  for i:=7 downto 0 do
    for j:=80 to 256 do
      begin
        PutPixel(j-i ,yP+i*2+1,GetPixel(j,yP+i));
        PutPixel(j-i ,yP+i*2,GetPixel(j,yP+i));
      end;
  Str(n,is);
  if n<100 then is:=' '+is;
  if n<10  then is:=is+' ';
  for i:=1 to 3 do
    begin
     if is[i]<>' ' then
       PutImage(i*24-24,192,Num[ ord(is[i])-ord('0') ]^,AndPut)
      else PutImage(i*24-24,192,Sym [ current ]^,AndPut);
    end;
    SetColor(LightGray);
end;
{---------------------------------------}
Procedure GetSym;
var
 Sz : Word;
begin
  FName:=Path+'F1.$c';
  GetZXScr;
  ViewZXScr(0);
  Sz:=ImageSize(0,0,23,23);
  for i:=0 to 9 do
    begin
      GetMem(Num[i],Sz);
      GetImage(i*24,0,23+i*24,24,Num[i]^);
    end;
  for i:=1 to 10 do
    begin
      GetMem(Sym[i],Sz);
      GetImage(i*24-24,24,i*24-1,48,Sym[i]^);
    end;
  FName:=Path+'compact.$c';
  GetZXScr;
  ViewZXScr(0);
  Inset;
end;
{---------------------------------------}
Function PrintLine(pos : integer) : boolean;
var
 rw,x,y,i,len :integer;
 d,b : byte;
begin
 PrintLine:=true;
 len:=Size*Column*Double;
 s:=#27'*'+chr(GrMode)+chr(len mod 256)+chr(len div 256);
 print(s);
 y:=pos*8;
 for rw:=1 to Column do
 for x:=0 to Size-1 do
  begin
   b:=0;
   for i:=0 to 7 do
     b:=b shl 1 + ( GetPixel(x,y+i) and 1 ) xor 1;
   for d:=1 to Double do  print(chr(b));
   if KeyPressed then
       if Readkey=#27  then
        begin
          PrintLine:=false;
          Exit;
        end;
  end;
end;
{---------------------------------------}
Procedure PrintZXscr;
var
  endline:byte;
begin
  endline:=23;
  if Ins then endline:=26;
  SetColor(Red);
  OutTextXY(20,280,'Printing...');
  for i:=1 to Row do
   begin
   print(#27#51#23);
   for j:=0 to endline do
    if not PrintLine(j) then
        begin
           R.AH:=1;
           R.DX:=0;
           Intr($17,R);
           Print(#13#10);
           exit;
        end
      else Print(#13#10);
   end
end;
{---------------------------------------}
Procedure Setup;
begin
 ClrScr;
 TextColor(Yellow);
 GoToXY(5,5);WriteLn('MultiPRINT v4.0   (c) 1993,94  Mednonogov bros.');
 GoToXY(1,10);
 TextColor(Cyan);
 Write(' ࠭ 䠩 (',Path,'): ');Readln(s);
 if s<>'' then Path:=s;
 Write('ᯮ짮  ⠢ [Y/n]? ');Readln(s);
 if (s='n') or (s='N') then Ins:=false else Ins:=true;
 Write('ਭ ⨭ (',Size,'): ');Readln(s);
 if s<>'' then Val(s,Size,i);
 Write('᪨ ० (',GrMode,'): ');Readln(s);
 if s<>'' then Val(s,GrMode,i);
 case GrMode of
  1,2: Double:=2;
  3  : Double:=4;
  else Double:=1;
 end
end;
{---------------------------------------}
Procedure ClrZXscr;
begin
  SetFillStyle(1,Black);
  Bar(0,0,520,217);
end;
{---------------------------------------}
Procedure CCat;
label
  Bye;
var
  oldDouble,OldGrMode,oldSize,page,sc,i,j,k,p1:integer;
  oldIns,void:boolean;
  name: string;
  ns:array[0..1] of string;
begin
  oldSize:=Size;
  oldIns:=Ins;
  oldDouble:=Double;
  oldGrMode:=GrMode;
  Size:=512;
  Ins:=False;
  Double:=1;
  GrMode:=5;
  name:=InputStr('Print catalogue from page:');
  val(name,p1,i);
  if i<>0 then exit;
  sc:=(p1-1)*8;
  while sc < Max do
    begin
      ClrZXscr;
      print(#27'W1          COMPACT STUDIO'#10#13);
      for i:=0 to 3 do
       begin
        for j:=0 to 1 do
        begin
          ns[j]:='     ';
          sc:=sc+1;
          if sc > Max then Fname:='compact'
            else
              begin
                str(ord(Dt[sc][1]),Fname);
                ns[j]:='N.'+copy(Fname+'   ',1,3);
                Fname:=Fname+'-60';
              end;
          Fname:=Path+Fname+'.$c';
          GetZXscr;
          ViewZXscr(j*256);
        end;
        print(#27'J'#17#27'W1 '+ns[0]+'             '+ns[1]+#27'3'#27#10#13);
        print(#27#51#23);
        for j:=0 to 23 do
         begin
            void:=not PrintLine(j);
            print(#13);
            if void or not PrintLine(j)  then
             begin
               R.AH:=1;
               R.DX:=0;
               Intr($17,R);
               Print(#13#10);
               goto Bye;
             end
            else Print(#13#10);
         end;
       end;
       str(p1,name);
       print(#27'W1            '#4#4#4' '+name+' '#4#4#4#10#13);
       inc(p1);
       ClrZXscr;
       SetColor(Yellow);
       OutTextXY(20,40,'End of page '+name);
       Pause;
       if c=#27 then begin ClrZXscr; goto Bye end;
    end;
Bye: ClrZXscr;
   OutTextXY(20,100,'End of catalogue !');
   Pause;
   ClrZXscr;
   Size:=oldSize;
   Ins:=oldIns;
   GrMode:=oldGrMode;
   Double:=oldDouble;
end;
{---------------------------------------}
Procedure PrList;
begin
  OutTextXY(20,300,'Cassette List Printing');
  print(#27'M'#27'R'#15'COMPACT Studio     (c) 1994'#13#10#10);
  for i := 1 to Max do
    begin
      j:=ord(Dt[i][1]);
      str(j,s);
      s:=copy(s+'    ',1,4)+copy(Dt[i]+'                         ',2,24)
         +copy(s+'     ',1,5);
      print(s+#27'-1|    |    |    |    |    |    |    |'#27'-0'#13#10);
    end;
  print(#12);
end;
{---------------------------------------}
Procedure MainMenu;
begin
  repeat
  SetFillStyle(1,Black);
  Bar (1,216,500,380);
  SetColor(LightGray);
  SetTextStyle(1,0,4);
  OutTextXY(02,390,'1:1x1  2:1x2  3:3x2  4:4x1  5:4x2');
  OutTextXY(02,420,'6:User L:List C:Catalogue Q:Quit Ent:New');
  Pause;
  case c of
  #0:Readkey;
  '1':begin Row:=1;Column:=1;PrintZXScr;end;
  '2':begin Row:=1;Column:=2;PrintZXScr;end;
  '3':begin Row:=3;Column:=2;PrintZXScr;end;
  '4':begin Row:=4;Column:=1;PrintZXScr;end;
  '5':begin Row:=4;Column:=2;PrintZXScr;end;
  '*','l','L':PrList;
  'c','C':CCat;
  #27,'Q','q':begin CloseGr; Halt(0); end;
  #13,' ':exit
  end;
  until false;
end;
{---------------------------------------}
begin
  SetUp;
  OpenGr;
  GetSym;
  repeat
  MainMenu;
  GetFName;
  GetZXscr;
  ViewZXscr(0);
  Inset;
  until false;
end.